% Sampling is done to discard the bad particles and replicate the good
% particles. After resampling, all particles will have an equal weights.


function [indx,corrindx,movindx,movcorrindx]=fourMovresampleRes1(weight,corrweight,movweight,movcorrweight)

    N=length(weight);
    corrN=length(corrweight);
    
    movN=length(movweight);
    movcorrN=length(movcorrweight);
    
    % Identified which particles is important via its weight
    Ns=floor(N.*weight);    
    corrNs=floor(corrN.*corrweight);
    
    movNs=floor(movN.*movweight);    
    movcorrNs=floor(movcorrN.*movcorrweight);
    
    % The "remainder" or "residual" of particles
    R=sum(Ns);
    corrR=sum(corrNs);
    
    movR=sum(movNs);
    movcorrR=sum(movcorrNs);
    
    % The number of particles which need to be generated
    N_generate=N-R;
    corrN_generate=corrN-corrR;
    
    movN_generate=movN-movR;
    movcorrN_generate=movcorrN-movcorrR;
    
    % The modified weights:
    Ws = (N .* weight - floor(N .* weight))/N_generate;
    corrWs = (corrN .* corrweight - floor(corrN .* corrweight))/corrN_generate;
    
    movWs = (movN .* movweight - floor(movN .* movweight))/movN_generate;
    movcorrWs = (movcorrN .* movcorrweight - floor(movcorrN .* movcorrweight))/movcorrN_generate;
    
    % Choose only important particles via its weights
    iter1=1;
    for j=1:N,
        for k=1:Ns(j),
            indx(iter1)=j;
            iter1=iter1+1;
        end
    end
    
    iter2=1;
    for j=1:corrN,
        for k=1:corrNs(j),
            corrindx(iter2)=j;
            iter2=iter2+1;
        end
    end
    
    iter3=1;
    for j=1:movN,
        for k=1:movNs(j),
            movindx(iter3)=j;
            iter3=iter3+1;
        end
    end
    
    iter4=1;
    for j=1:movcorrN,
        for k=1:movcorrNs(j),
            movcorrindx(iter4)=j;
            iter4=iter4+1;
        end
    end
    
    % Find the cumulative sum
    Q=cumsum(Ws);
    Q(N)=1; % Just in case...
    
    corrQ=cumsum(corrWs);
    corrQ(corrN)=1; % Just in case...
    
    movQ=cumsum(movWs);
    movQ(movN)=1; % Just in case...
    
    movcorrQ=cumsum(movcorrWs);
    movcorrQ(movcorrN)=1; % Just in case...
    
    for i=1:N
        a(i)=rand(1,1);
    end
    
    while (iter1<=N),
        i=1;
        sampl=a(i);    % Generate random variable uniformly distribted [0,1]
        j=1;
        i=i+1;
        while (Q(j)<sampl),
            j=j+1;
        end;
    indx(iter1)=j;     
    iter1=iter1+1;
    end
    
    while (iter2<=N),
        i=1;
        corrsampl=a(i);    % Generate random variable uniformly distribted [0,1]
        j=1;
        i=i+1;
        while (Q(j)<corrsampl),
            j=j+1;
        end;
    corrindx(iter2)=j;     
    iter2=iter2+1;
    end
    
    while (iter3<=movN),
        i=1;
        movsampl=a(i);    % Generate random variable uniformly distribted [0,1]
        j=1;
        i=i+1;
        while (movQ(j)<movsampl),
            j=j+1;
        end;
    movindx(iter3)=j;     
    iter3=iter3+1;
    end
    
    while (iter4<=movN),
        i=1;
        movcorrsampl=a(i);    % Generate random variable uniformly distribted [0,1]
        j=1;
        i=i+1;
        while (movQ(j)<movcorrsampl),
            j=j+1;
        end;
    movcorrindx(iter4)=j;     
    iter4=iter4+1;
    end
    
end

